--- a/Makefile
+++ b/Makefile
@@ -21,12 +21,8 @@ USEGUI_CFLAGS=
 WARNING_CFLAGS=-Wno-pointer-sign
 BASE_CFLAGS+=$(WARNING_CFLAGS)
 BASE_CFLAGS+=$(USEGUI_CFLAGS)
+BASE_LDFLAGS+=$(LDFLAGS)
 
-ifneq ($(DEBUG),)
-	BASE_CFLAGS+=-ggdb
-else
-	BASE_LDFLAGS+=-s
-endif
 BASE_LDFLAGS+=-lz
 # set to "" for debugging
 
@@ -35,11 +31,11 @@ DO_CC?=$(CC) $(BASE_CFLAGS) -o $@ -c $< $(CFLAGS)
 lib: 
 
 R_win_nocyg: $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS)
-	$(CC) $(BASE_CFLAGS) -o fteqcc.exe -O3 $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mno-cygwin -mwindows -lcomctl32 -lole32 -lshlwapi
+	$(CC) $(BASE_CFLAGS) -o fteqcc.exe $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mno-cygwin -mwindows -lcomctl32 -lole32 -lshlwapi
 R_nocyg: $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS)
-	$(CC) $(BASE_CFLAGS) -o fteqcc.exe -O3 $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mno-cygwin -lcomctl32 -lole32 -lshlwapi
+	$(CC) $(BASE_CFLAGS) -o fteqcc.exe $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mno-cygwin -lcomctl32 -lole32 -lshlwapi
 R_win: $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS)
-	$(CC) $(BASE_CFLAGS) -o fteqcc.exe -O3 $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mwindows -lcomctl32 -lole32 -lshlwapi
+	$(CC) $(BASE_CFLAGS) -o fteqcc.exe $(BASE_LDFLAGS) $(QCC_OBJS) $(COMMON_OBJS) $(WIN32GUI_OBJS) -mwindows -lcomctl32 -lole32 -lshlwapi
 
 win_nocyg:
 	$(MAKE) USEGUI_CFLAGS="-DUSEGUI -DQCCONLY" R_win_nocyg
@@ -49,7 +45,7 @@ win:
 	$(MAKE) USEGUI_CFLAGS="-DUSEGUI -DQCCONLY" R_win
 
 R_qcc: $(QCC_OBJS) $(COMMON_OBJS) $(TUI_OBJS)
-	$(CC) $(BASE_CFLAGS) -o fteqcc.bin -O3 $(QCC_OBJS) $(TUI_OBJS) $(COMMON_OBJS) $(BASE_LDFLAGS) -lm
+	$(CC) $(BASE_CFLAGS) -o fteqcc.bin $(QCC_OBJS) $(TUI_OBJS) $(COMMON_OBJS) $(BASE_LDFLAGS) -lm -lz
 qcc:
 	$(MAKE) USEGUI_CFLAGS="" R_qcc
 
@@ -87,7 +83,7 @@ qcc_gtk.o: qcc_gtk.c qcc.h
 	$(DO_CC) `pkg-config --cflags gtk+-2.0`
 
 R_gtkgui: $(QCC_OBJS) $(COMMON_OBJS) $(GTKGUI_OBJS)
-	$(CC) $(BASE_CFLAGS) $(USEGUI_CFLAGS) -o fteqccgui.bin -O3 $(GTKGUI_OBJS) $(QCC_OBJS) $(COMMON_OBJS) `pkg-config --libs gtk+-2.0`
+	$(CC) $(BASE_CFLAGS) $(USEGUI_CFLAGS) -o fteqccgui.bin $(GTKGUI_OBJS) $(QCC_OBJS) $(COMMON_OBJS) `pkg-config --libs gtk+-2.0`
 gtkgui:
 	$(MAKE) USEGUI_CFLAGS="-DUSEGUI -DQCCONLY" R_gtkgui
 
@@ -95,7 +91,7 @@ clean:
 	$(RM) fteqcc.bin fteqcc.exe $(QCC_OBJS) $(COMMON_OBJS) $(VM_OBJS) $(GTKGUI_OBJS) $(WIN32GUI_OBJS) $(TUI_OBJS)
 
 qcvm.so: $(QCC_OBJS) $(VM_OBJS) $(COMMON_OBJS)
-	$(CC) $(BASE_CFLAGS) -o $@ -O3 $(BASE_LDFLAGS) $(QCC_OBJS) $(VM_OBJS) $(COMMON_OBJS) -shared
+	$(CC) $(BASE_CFLAGS) -o $@ $(BASE_LDFLAGS) $(QCC_OBJS) $(VM_OBJS) $(COMMON_OBJS) -shared
 qcvm.a: $(QCC_OBJS) $(VM_OBJS) $(COMMON_OBJS)
 	ar r $@ $^
 
@@ -103,7 +99,7 @@ test.o: test.c
 	$(DO_CC)
 
 qcvm: test.o qcvm.a
-	$(CC) $(BASE_CFLAGS) $(CFLAGS) -o qcvm -O3 $(BASE_LDFLAGS) $^ -lm -lz -ggdb
+	$(CC) $(BASE_CFLAGS) $(CFLAGS) -o qcvm $(BASE_LDFLAGS) $^ -lm -lz
 
 tests: qcvm
 	@echo Running Tests...
